#include "ThermometerPro.h"

#include "cmd.h"
#include "uptime.h"
#include "thermometer.h"
#include "Config.h"
#include "spi.h"
#include "meterBusClient.h"


const unsigned char OK_LED_PIN = 2;

static CmdServer cmdServer(&Serial);
static ConfigInvalidateCmd configInvalidateCmd;
static Uptime uptime;
static Thermometer thermometer;
static MeterBusClient meterBusClient;

void setup() {
  pinMode(OK_LED_PIN, OUTPUT);
  digitalWrite(OK_LED_PIN, LOW);

  // delay(5000);

  Serial.begin(115200);

  Config::initialize();


  spiInit();

  cmdServer.begin();
  configInvalidateCmd.registerYourself(&cmdServer);
  uptime.begin(&cmdServer);
  thermometer.begin(&cmdServer);
  meterBusClient.begin(&cmdServer, &thermometer);

  digitalWrite(OK_LED_PIN, HIGH);
}


void loop() {
  cmdServer.exec();
  uptime.exec();
  thermometer.exec();
  meterBusClient.exec();
}
